#
# spec file for package ghc-compact
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%global pkg_name compact
%bcond_with tests
Name:           ghc-%{pkg_name}
Version:        0.1.0.1
Release:        5.1
Summary:        Non-GC'd, contiguous storage for immutable data structures
License:        BSD-3-Clause
Group:          Development/Libraries/Haskell
URL:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
Source1:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/revision/1.cabal#/%{pkg_name}.cabal
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-binary-devel
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-ghc-compact-devel
BuildRequires:  ghc-rpm-macros
%if %{with tests}
BuildRequires:  ghc-directory-devel
%endif

%description
This package provides user-facing APIs for working with "compact regions",
which hold a fully evaluated Haskell object graph. These regions maintain the
invariant that no pointers live inside the struct that point outside it, which
ensures efficient garbage collection without ever reading the structure
contents (effectively, it works as a manually managed "oldest generation" which
is never freed until the whole is released). This package is currently highly
experimental, but we hope it may be useful to some people. It is GHC 8.2 only.
The bare-bones library that ships with GHC is ghc-compact.

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Haskell
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%setup -q -n %{pkg_name}-%{version}
cp -p %{SOURCE1} %{pkg_name}.cabal

%build
%ghc_lib_build

%install
%ghc_lib_install

%check
%cabal_test

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%license LICENSE

%files devel -f %{name}-devel.files
%doc ChangeLog.md README.md

%changelog
* Wed Mar 14 2018 psimons@suse.com
- Update compact to version 0.1.0.1.
  A more detailed change log is not available.
